#!/bin/sh
# compress a folder  -gzip or xz formats
# Demo to show automatica fill in of entry box
# june1 2012 Don White (don570)
#June6 time estimate

#  can be used if gtkdialog3 isn't installed
export GTKDIALOG=gtkdialog

# start with clean /tmp
rm -f  /tmp/compression_*


  
###############################################
#                                             #
#              COMPRESSION                    #
#                                             #
###############################################
  
compression(){
	# check if empty field
	if [ -z "$DIR" ] ;then
Xdialog --title "Warning"   --wrap --screen-center --no-buttons --msgbox "
A folder must be selected for compression. "   10 49 100 &
exit 0
fi

# find directory that will be compressed by removal between slashes
DIRECTORY="${DIR##/*/}"
# move to directory that will be compressed
cd "$DIR"
cd ..
if [  "$GZIP_value" = "true" ] ; then
tar cvzf "$DIRECTORY".tar.gz "$DIRECTORY"
Xdialog --title "Compress"   --wrap --screen-center --left --no-buttons --msgbox  "Archive name:  $DIRECTORY.tar.gz
Storage location:   $PWD  "   10 55 100  & 
fi 
if [  "$XZ_value" = "true" ] ; then
tar cvJf "$DIRECTORY".txz "$DIRECTORY"
Xdialog --title "Compress"   --wrap --screen-center --left --no-buttons --msgbox  "Archive name:  $DIRECTORY.txz
Storage location:   $PWD  "   10 55 100  & 
fi
if [  "$ZIP_value" = "true" ] ; then
zip -vr "$DIRECTORY".zip "$DIRECTORY"
Xdialog --title "Compress"   --wrap --screen-center --left --no-buttons --msgbox  "Archive name:  $DIRECTORY.zip
Storage location:   $PWD  "   10 55 100  & 
fi
rm -f  /tmp/compression_*
exit 0
}
export -f compression



###############################################
#                                             #
#                       ESTIMATE                    #
#                                             #
###############################################
estimate(){

SIZE=`ls -Ras1 "$DIR" | sed -n '/total/p'  | awk '{ print  $2 }'`
sync
COUNT=0

for number in $SIZE
do
let "COUNT=$COUNT + $number"
done
SIZE=$COUNT

let "TIME_ESTIMATE = $SIZE * 39 / 247000"
if  [   "$TIME_ESTIMATE" -le 0  ];then
TIME_ESTIMATE=1
fi
echo $TIME_ESTIMATE > /tmp/compression_estimate

	
}
export -f estimate


###############################################
#                                             #
#               M A I N   G U I               #
#                                             #
###############################################

export COMPRESS='
<window title="Compression Demo" icon-name="mini-modules" resizable="false" decorated="true">
<vbox   width-request="340">
 

<text height-request="10"><label>""</label></text>
        <text><label>"Choose a folder
and click COMPRESS"</label></text>
 
 <hbox>       
        <entry accept="directory">
        <label>Select a Directory</label>
        <input>cat  /tmp/compression_path</input>
        <variable>DIR</variable>
        </entry>
        <button>
        <input file stock="gtk-open"></input>
        <action type="fileselect">DIR</action>
                <action>estimate</action>  
                <action>refresh:TIME</action>    

              
       </button>   
</hbox>

<radiobutton>
        <label>"GZIP compression"</label>
        <default>true</default>
        <variable>GZIP_value</variable>
</radiobutton>
<radiobutton>
        <label>"XZ compression"</label>
        <variable>XZ_value</variable>
</radiobutton> 
<radiobutton>
        <label>"ZIP compression"</label>
        <variable>ZIP_value</variable>
</radiobutton> 
<text height-request="20"><label>""</label></text>

<hbox homogeneous="true">
<text>
      <label>Time for compression</label>
</text>
  </hbox>
  
 <hbox>
      <hbox width-request="210">    
 <entry editable="false">    
    <variable>TIME</variable>
    <input>cat /tmp/compression_estimate</input>
  </entry>
  <text>
      <label>seconds</label>
      </text>
  
       <text><label>                      </label></text>
     </hbox>
</hbox>  
        <text><label>____________________________________________</label></text>
        
<hbox homogeneous="true">

 <button>
        <input file stock="gtk-cancel"></input>
        <label>Cancel</label>
        <action type="exit">CLOSE</action>
</button>

<button can-default="true" has-default="true" use-stock="true">
      <input file stock="gtk-ok"></input>
      <label>"COMPRESS"</label>        
      <action>compression &</action>  
      <action type="exit">CLOSE</action>           
</button>     
</hbox>
</vbox>



</window>'

$GTKDIALOG  --geometry=+200+100 -p COMPRESS


