#!/bin/sh
# compress a folder  -gzip or xz formats
# demo of refresh button
# june1 2012 Don White (don570)
#June6 time estimate

# flexible to use gtkdialog3
export GTKDIALOG=gtkdialog
if [ -e /usr/sbin/gtkdialog3 ] ;then
export GTKDIALOG=gtkdialog3
fi

# start with clean /tmp
rm -f  /tmp/compression_*


  
###############################################
#                                             #
#              COMPRESSION                    #
#                                             #
###############################################
  
compression(){
	# check if empty field
	if [ -z "$DIR" ] ;then
Xdialog --title "Warning"   --wrap --screen-center --no-buttons --msgbox "
A folder must be selected for compression. "   10 49 100 &
exit 0
fi

# find directory that will be compressed by removal between slashes
DIRECTORY="${DIR##/*/}"
# move to directory that will be compressed
cd "$DIR"
cd ..
if [  "$GZIP_value" = "true" ] ; then
tar cvzf "$DIRECTORY".tar.gz "$DIRECTORY"
Xdialog --title "Compress"   --wrap --screen-center --left --no-buttons --msgbox  "Archive name:  $DIRECTORY.tar.gz
Storage location:   $PWD  "   10 55 100  & 
fi 
if [  "$XZ_value" = "true" ] ; then
tar cvJf "$DIRECTORY".txz "$DIRECTORY"
Xdialog --title "Compress"   --wrap --screen-center --left --no-buttons --msgbox  "Archive name:  $DIRECTORY.txz
Storage location:   $PWD  "   10 55 100  & 
fi
if [  "$ZIP_value" = "true" ] ; then
zip -vr "$DIRECTORY".zip "$DIRECTORY"
Xdialog --title "Compress"   --wrap --screen-center --left --no-buttons --msgbox  "Archive name:  $DIRECTORY.zip
Storage location:   $PWD  "   10 55 100  & 
fi

exit 0
}
export -f compression



###############################################
#                                             #
#                       ESTIMATE                    #
#                                             #
###############################################
estimate(){

SIZE=`ls -Ras1 "$DIR" | sed -n '/total/p'  | awk '{ print  $2 }'`
sync
COUNT=0

# add up individual sizes
for number in $SIZE
do
let "COUNT=$COUNT + $number"
done
SIZE=$COUNT

#convert size to time with multiplication factor
let "TIME_ESTIMATE = $SIZE * 39 / 247000"
if  [   "$TIME_ESTIMATE" -le 0  ];then
TIME_ESTIMATE=1
fi
echo $TIME_ESTIMATE > /tmp/compression_estimate

	
}
export -f estimate

###############################################
#                                             #
#               M A I N   G U I               #
#                                             #
###############################################

export COMPRESS='
<window title="Refresh Demo" icon-name="mini-modules" resizable="false" decorated="true">
<vbox   width-request="340">
 

<text height-request="10"><label>""</label></text>
        <text><label>"Choose a folder
and click COMPRESS"</label></text>
 
 <hbox>       
        <entry accept="directory">
        <label>Select a Directory</label>
        <input>cat  /tmp/compression_path</input>
        <variable>DIR</variable>
        </entry>
        <button>
        <input file stock="gtk-open"></input>
        <action type="fileselect">DIR</action>
              
       </button>   
</hbox>

<radiobutton>
        <label>"GZIP compression"</label>
        <default>true</default>
        <variable>GZIP_value</variable>
</radiobutton>
<radiobutton>
        <label>"XZ compression"</label>
        <variable>XZ_value</variable>
</radiobutton> 
<radiobutton>
        <label>"ZIP compression"</label>
        <variable>ZIP_value</variable>
</radiobutton> 
<text height-request="20"><label>""</label></text>

<frame Time for compression>
<hbox>
    <text>
      <label>(seconds)</label>
    </text>
    <hbox width-request="150">
 <entry>    
    <variable>TIME</variable>
    <input>cat /tmp/compression_estimate</input>
  </entry>
  
       <button>
         <label>Refresh</label>
         <input file stock="gtk-refresh"></input>        
         <action>estimate</action>
         <action type="refresh">TIME</action>
       </button>
    </hbox>
</hbox>
  </frame>
        <text><label>____________________________________________</label></text>
        
<hbox homogeneous="true">

 <button>
        <input file stock="gtk-cancel"></input>
        <label>Cancel</label>
        <action type="exit">CLOSE</action>
</button>

<button can-default="true" has-default="true" use-stock="true">
      <input file stock="gtk-ok"></input>
      <label>"COMPRESS"</label>     
      <action>compression &</action>  
      <action type="exit">CLOSE</action>           
</button>     
</hbox>
</vbox>


</window>'

$GTKDIALOG  --geometry=+200+100 -p COMPRESS


